#include "motor.h"

Motor *Motor::letztesElement;

Motor::Motor(){

  vorherElement = Motor::letztesElement;
  Motor::letztesElement = this;
  this->pinA = pinA;
  this->pinB = pinB;

}


Motor::~Motor(){

}

void Motor::setPins(uint8_t pinA , uint8_t pinB){
  this->pinA = pinA;
  this->pinB = pinB;
}

void Motor::setup(){
  if(Motor::letztesElement){
    Motor::letztesElement->localSetup();
  }
  Timer1.initialize(100); // 10kHz
  Timer1.attachInterrupt(Motor::interruptEinsprung);

}

void Motor::loop(){
  if(Motor::letztesElement){
    Motor::letztesElement->localLoop();
  }
}

void Motor::localSetup(){
  mySetup();
  if(vorherElement){
    vorherElement->localSetup();
  }else{

  }
  
}

void Motor::mySetup(){
  pinMode(pinA , OUTPUT);
  digitalWrite( pinA , 0);

  pinMode(pinB , OUTPUT);
  digitalWrite(pinB , 0);
}


void Motor::localLoop(){
  myLoop();
  if(vorherElement){
    vorherElement->localLoop();
  }else{

  }
}

void Motor::myLoop(){
  if(richtung){
    if(test == 32767)
      richtung = !richtung;
    else
      test ++;
  }else{
    if(test == -32767)
      richtung = !richtung;
    else
      test --;
  }
  setSollSpeed( test / 64);
  //setSollSpeed(100);
}


void Motor::setSollSpeed(int16_t speed){
  if(speed > 256)
    speed = 256;
  if((speed < 100) && (speed > -100))
    speed = 0;
  if(speed < -256)
    speed = -256;

  sollSpeed = speed;

}


void Motor::interruptEinsprung(){
  if(letztesElement)
    letztesElement->localInterruptEinsprung();
}
void Motor::localInterruptEinsprung(){
  interruptBerechnungen();
  if(vorherElement){
    vorherElement->localInterruptEinsprung();
  }else{
    timer ++;
    //digitalWrite(LED_DEBUG , (timer & 0x100) != 0 );
  }
}

void Motor::interruptBerechnungen(){
  summeSpeed += sollSpeed;
  if(summeSpeed >= 256)
  {
    summeSpeed -= 256;
    digitalWrite(pinA , 0);
    digitalWrite(pinB , 1);

  }else if (summeSpeed <= -256){
    summeSpeed += 256;
    digitalWrite(pinA , 1);
    digitalWrite(pinB , 0);

  }else{
    digitalWrite(pinA , 0);
    digitalWrite(pinB , 0);

  }
  
}
