#ifndef MOTOR_H
#define MOTOR_H

#include <TimerOne.h>
#include "pins.h"

class Motor{

public:
  Motor();
  Motor(uint8_t pinA , uint8_t pinB);

  virtual ~Motor();

  static void setup();
  static void loop();

  void setPins(uint8_t pinA , uint8_t pinB);

  void setSollSpeed(int16_t speed);

protected:

  static Motor *letztesElement;
  Motor *vorherElement;

  void localSetup();
  void localLoop();

  void mySetup();
  void myLoop();

  static void interruptEinsprung();
  void localInterruptEinsprung();

  void interruptBerechnungen();

  uint8_t pinA , pinB;
  uint16_t timer;

  int16_t sollSpeed; 
  int16_t summeSpeed;

  bool richtung;
  int16_t test;
  
};



#endif